commit c74ba9434a7ceb9aa494c490831d2ff564c65625
Author: freddy77 <freddy77>
Date:   Wed Jan 27 12:22:00 2010 +0000

    use Negotiate and provide SPN in order to enable Kerberos support using SSPI

diff --git a/ChangeLog b/ChangeLog
index cf78d98..1a4476a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Jan 27 13:20:42 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/sspi.c:
+	- use Negotiate and provide SPN in order to enable Kerberos support
+	  using SSPI
+
 Wed Jan 27 13:14:46 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/odbc/connectparams.c src/tds/config.c:
 	- set correctly server_host_name from odbc
@@ -2219,4 +2224,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2963 2010/01/27 12:16:09 freddy77 Exp $
+$Id: ChangeLog,v 1.2964 2010/01/27 12:22:00 freddy77 Exp $
diff --git a/src/tds/sspi.c b/src/tds/sspi.c
index 072fb56..51ee44e 100644
--- a/src/tds/sspi.c
+++ b/src/tds/sspi.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sspi.c,v 1.4 2010/01/27 08:31:26 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sspi.c,v 1.5 2010/01/27 12:22:00 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -63,6 +63,7 @@ typedef struct tds_sspi_auth
 	TDSAUTHENTICATION tds_auth;
 	CredHandle cred;
 	CtxtHandle cred_ctx;
+	char *sname;
 } TDSSSPIAUTH;
 
 static HMODULE secdll = NULL;
@@ -108,6 +109,7 @@ tds_sspi_free(TDSSOCKET * tds, struct tds_authentication * tds_auth)
 	sec_fn->DeleteSecurityContext(&auth->cred_ctx);
 	sec_fn->FreeCredentialsHandle(&auth->cred);
 	free(auth->tds_auth.packet);
+	free(auth->sname);
 	free(auth);
 	return TDS_SUCCEED;
 }
@@ -147,7 +149,7 @@ tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size
 	out_buf.pvBuffer   = auth->tds_auth.packet;
 	out_buf.cbBuffer   = NTLMBUF_LEN;
 
-	status = sec_fn->InitializeSecurityContext(&auth->cred, &auth->cred_ctx, NULL /* TODO SPN */,
+	status = sec_fn->InitializeSecurityContext(&auth->cred, &auth->cred_ctx, auth->sname,
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP, &in_desc,
 		0, &auth->cred_ctx, &out_desc,
@@ -157,6 +159,8 @@ tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size
 
 	if (status != SEC_E_OK)
 		return TDS_FAIL;
+	if (out_buf.cbBuffer == 0)
+		return TDS_SUCCEED;
 
 	tds_put_n(tds, auth->tds_auth.packet, out_buf.cbBuffer);
 
@@ -176,14 +180,14 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	ULONG attrs;
 	TimeStamp ts;
 	SEC_WINNT_AUTH_IDENTITY identity;
-	const char *p, *user_name;
+	const char *p, *user_name, *server_name;
 
 	TDSSSPIAUTH *auth;
 	TDSCONNECTION *connection = tds->connection;
 
 	/* check connection */
 	if (!connection)
-		return TDS_FAIL;
+		return NULL;
 
 	if (!tds_init_secdll())
 		return NULL;
@@ -193,12 +197,12 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	user_name = tds_dstr_cstr(&connection->user_name);
 	if ((p = strchr(user_name, '\\')) != NULL) {
 		identity.Flags = SEC_WINNT_AUTH_IDENTITY_ANSI;
-		identity.Password = (unsigned short *) tds_dstr_cstr(&connection->password);
+		identity.Password = (void *) tds_dstr_cstr(&connection->password);
 		identity.PasswordLength = tds_dstr_len(&connection->password);
-		identity.Domain = (unsigned short *) user_name;
+		identity.Domain = (void *) user_name;
 		identity.DomainLength = p - user_name;
 		user_name = p + 1;
-		identity.User = (unsigned short *) user_name;
+		identity.User = (void *) user_name;
 		identity.UserLength = strlen(user_name);
 	}
 
@@ -210,13 +214,14 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	auth->tds_auth.handle_next = tds_sspi_handle_next;
 
 	/* TODO use SPNEGO to use Kerberos if possible */
-	if (sec_fn->AcquireCredentialsHandle(NULL, (char *)"NTLM", SECPKG_CRED_OUTBOUND,
+	if (sec_fn->AcquireCredentialsHandle(NULL, (char *)"Negotiate", SECPKG_CRED_OUTBOUND,
 		NULL, identity.Domain ? &identity : NULL,
 		NULL, NULL, &auth->cred, &ts) != SEC_E_OK) {
 		free(auth);
 		return NULL;
 	}
 
+	/* allocate buffer */
 	auth->tds_auth.packet = (TDS_UCHAR *) malloc(NTLMBUF_LEN);
 	if (!auth->tds_auth.packet) {
 		sec_fn->FreeCredentialsHandle(&auth->cred);
@@ -231,7 +236,27 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	buf.BufferType = SECBUFFER_TOKEN;
 	buf.pvBuffer   = auth->tds_auth.packet;
 
-	status = sec_fn->InitializeSecurityContext(&auth->cred, NULL, "" /* TODO SPN */,
+	/* build SPN */
+	server_name = tds_dstr_cstr(&connection->server_host_name);
+	if (strchr(server_name, '.') == NULL) {
+		struct hostent result;
+		int h_errnop;
+
+		struct hostent *host = tds_gethostbyname_r(server_name, &result, auth->tds_auth.packet, NTLMBUF_LEN, &h_errnop);
+		if (host && strchr(host->h_name, '.') != NULL)
+			server_name = host->h_name;
+	}
+	if (strchr(server_name, '.') != NULL) {
+		if (asprintf(&auth->sname, "MSSQLSvc/%s:%d", server_name, connection->port) < 0) {
+			free(auth->tds_auth.packet);
+			sec_fn->FreeCredentialsHandle(&auth->cred);
+			free(auth);
+			return NULL;
+		}
+		tdsdump_log(TDS_DBG_NETWORK, "kerberos name %s\n", auth->sname);
+	}
+
+	status = sec_fn->InitializeSecurityContext(&auth->cred, NULL, auth->sname,
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP,
 		NULL, 0,
@@ -241,6 +266,7 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	if (status == SEC_I_COMPLETE_AND_CONTINUE || status == SEC_I_CONTINUE_NEEDED) {
 		sec_fn->CompleteAuthToken(&auth->cred_ctx, &desc);
 	} else if(status != SEC_E_OK) {
+		free(auth->sname);
 		free(auth->tds_auth.packet);
 		sec_fn->FreeCredentialsHandle(&auth->cred);
 		free(auth);

